//Pico_ADpwm
  
#include "pico/stdlib.h"
#include "hardware/adc.h"
#include "hardware/pwm.h"

void setup() {
  int ad=0;
  int iir=0;
  int pwm=0;
  int n, d;
  Serial.begin(115200);
  adc_init();
  adc_gpio_init(26);
  adc_select_input(0);

  gpio_set_function(0, GPIO_FUNC_PWM);
  pwm_set_wrap(0, 4095);
  pwm_set_gpio_level(0, 0);
  pwm_set_enabled(0, true);
  gpio_pull_up(4);
  gpio_pull_up(8);
  
  while(true){
    for (n=0; n<50; n++){
      ad = adc_read();
      iir = (iir*9+ad)/10; 
      sleep_ms(10);
    }   
    Serial.print(pwm*3300/4095);
    Serial.print(" mV   ");
    Serial.print(iir*3300/4095);
    Serial.println(" mV");
    if (gpio_get(4)==0) pwm-=d;
    if (pwm<0) pwm=0;
    if (gpio_get(8)==0) pwm+=d;
    pwm_set_gpio_level(0, pwm);
    d++;
    if ((gpio_get(4)==1) & (gpio_get(8)==1)) d=1;
  }
} 

void loop() {}
