//Pico_Scope2 Zweikanal  
#include "pico/stdlib.h"
#include "hardware/adc.h"
#include "hardware/pwm.h"
#include "pico/multicore.h"

void setup() {
  Serial.begin(115200); 
}

void loop() {
}  
  
void setup1() {
  unsigned int scope[1000]; 
  unsigned int dt, dt2;
  dt=10;
  gpio_set_function(0, GPIO_FUNC_PWM);
  pwm_set_wrap(0, 62499);  //PWM 2 kHz, 50%
  pwm_set_gpio_level(0, 31250);
  pwm_set_enabled(0, true);
  adc_init();
  adc_gpio_init(26);
  adc_gpio_init(27);
  adc_select_input(0);  
  while (true) { 
    if (Serial.available()){
      dt2 = Serial.parseInt();
      if( dt2>0) dt=dt2;
    }
    uint32_t t = time_us_32();
    for (int n = 0; n < 500; n++){
      adc_select_input(0);
      scope[2*n]=adc_read();
      adc_select_input(1);
      scope[2*n+1]=adc_read();
      t+=dt;
      while (t>time_us_32());  
    }
    for (int n = 0; n < 500; n++){
      Serial.print ((int) scope[2*n]*3300/4095);
      Serial.print (" ");
      Serial.print ((int) scope[2*n+1]*3300/4095);
      Serial.print (" ");
      Serial.print (0);
      Serial.print (" ");
      Serial.println (3300);
    }
    sleep_ms(1000);
  }
}  


void loop1() {
}
