//Pico_SweepDDS   
#include "pico/stdlib.h"
#include "hardware/adc.h"
#include "hardware/pwm.h"
#include "pico/multicore.h"

unsigned int scope[1000]; 
unsigned int dds[1024]; 
uint16_t akku, i; 
unsigned int f, dp;

void setup() {
  f=10000;
  dp=f*64/200;
  Serial.begin(115200); 
  for (int j = 0; j < 1024; j++){
    dds[j]=312+300* sin(2*PI*j/1024.0);
  }
  while(true){
    if (Serial.available()){
      f = Serial.parseInt();
      if( f>0) dp=f*64/200;
    }
    i=0;
    sleep_ms(1000);
      for (int j = 0; j < 500; j++){
      Serial.println ((int) scope[j]*3300/4095);
      }
  }
}

void loop() {}  
  
void setup1() {
  adc_init();
  adc_gpio_init(26);
  adc_select_input(0);  
  
  gpio_set_function(0, GPIO_FUNC_PWM);
  pwm_set_wrap(0, 624);  //PWM 200 kHz
  pwm_set_gpio_level(0, 312);
  pwm_set_enabled(0, true);
  pwm_set_irq_enabled(0, true);
  irq_set_exclusive_handler(PWM_IRQ_WRAP, pwm_int); 
  irq_set_enabled(PWM_IRQ_WRAP, true);
  while (true);
}  

void pwm_int() {
  pwm_clear_irq(0);
  pwm_set_gpio_level(0, dds[akku>>6]);
  if (i>499) akku=0;   //312<<6;
  if (i<500){
    akku+=dp*i/500;
    scope[i]=adc_read();
    i++;
  }
}

void loop1() {}
